package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.PgDB;

/**
 * PostgreSQL integration tests for the `Exists` object / `existsBy*` connection extension functions
 */
@DisplayName("Core | Java | PostgreSQL: Exists")
final public class PostgreSQLExistsIT {

    @Test
    @DisplayName("byId returns true when a document matches the ID")
    public void byIdMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byIdMatch(db);
        }
    }

    @Test
    @DisplayName("byId returns false when no document matches the ID")
    public void byIdNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byIdNoMatch(db);
        }
    }

    @Test
    @DisplayName("byFields returns true when documents match")
    public void byFieldsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byFieldsMatch(db);
        }
    }

    @Test
    @DisplayName("byFields returns false when no documents match")
    public void byFieldsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byFieldsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byContains returns true when documents match")
    public void byContainsMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byContainsMatch(db);
        }
    }

    @Test
    @DisplayName("byContains returns false when no documents match")
    public void byContainsNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byContainsNoMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath returns true when documents match")
    public void byJsonPathMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byJsonPathMatch(db);
        }
    }

    @Test
    @DisplayName("byJsonPath returns false when no documents match")
    public void byJsonPathNoMatch() throws DocumentException {
        try (PgDB db = new PgDB()) {
            ExistsFunctions.byJsonPathNoMatch(db);
        }
    }
}
