package solutions.bitbadger.documents.core.tests.integration

import solutions.bitbadger.documents.DocumentSerializer
import com.fasterxml.jackson.databind.ObjectMapper

/**
 * A JSON serializer using Jackson's default options
 */
class JacksonDocumentSerializer : DocumentSerializer {

    private val mapper = ObjectMapper()

    override fun <TDoc> serialize(document: TDoc): String =
        mapper.writeValueAsString(document)

    override fun <TDoc> deserialize(json: String, clazz: Class<TDoc>): TDoc =
        mapper.readValue(json, clazz)
}
