package solutions.bitbadger.documents.core.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Definition` object / `ensure*` connection extension functions
 */
@DisplayName("Core | Kotlin | PostgreSQL: Definition")
class PostgreSQLDefinitionIT {

    @Test
    @DisplayName("ensureTable creates table and index")
    fun ensureTable() =
        PgDB().use(DefinitionFunctions::ensureTable)

    @Test
    @DisplayName("ensureFieldIndex creates an index")
    fun ensureFieldIndex() =
        PgDB().use(DefinitionFunctions::ensureFieldIndex)

    @Test
    @DisplayName("ensureDocumentIndex creates a full index")
    fun ensureDocumentIndexFull() =
        PgDB().use(DefinitionFunctions::ensureDocumentIndexFull)

    @Test
    @DisplayName("ensureDocumentIndex creates an optimized index")
    fun ensureDocumentIndexOptimized() =
        PgDB().use(DefinitionFunctions::ensureDocumentIndexOptimized)
}
