package solutions.bitbadger.documents.core.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * PostgreSQL integration tests for the `Patch` object / `patchBy*` connection extension functions
 */
@DisplayName("Core | Kotlin | PostgreSQL: Patch")
class PostgreSQLPatchIT {

    @Test
    @DisplayName("byId patches an existing document")
    fun byIdMatch() =
        PgDB().use(PatchFunctions::byIdMatch)

    @Test
    @DisplayName("byId succeeds for a non-existent document")
    fun byIdNoMatch() =
        PgDB().use(PatchFunctions::byIdNoMatch)

    @Test
    @DisplayName("byFields patches matching document")
    fun byFieldsMatch() =
        PgDB().use(PatchFunctions::byFieldsMatch)

    @Test
    @DisplayName("byFields succeeds when no documents match")
    fun byFieldsNoMatch() =
        PgDB().use(PatchFunctions::byFieldsNoMatch)

    @Test
    @DisplayName("byContains patches matching document")
    fun byContainsMatch() =
        PgDB().use(PatchFunctions::byContainsMatch)

    @Test
    @DisplayName("byContains succeeds when no documents match")
    fun byContainsNoMatch() =
        PgDB().use(PatchFunctions::byContainsNoMatch)

    @Test
    @DisplayName("byJsonPath patches matching document")
    fun byJsonPathMatch() =
        PgDB().use(PatchFunctions::byJsonPathMatch)

    @Test
    @DisplayName("byJsonPath succeeds when no documents match")
    fun byJsonPathNoMatch() =
        PgDB().use(PatchFunctions::byJsonPathNoMatch)
}
