package solutions.bitbadger.documents.core.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.assertThrows
import solutions.bitbadger.documents.DocumentException
import kotlin.test.Test

/**
 * SQLite integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName("Core | Kotlin | SQLite: Count")
class SQLiteCountIT {

    @Test
    @DisplayName("all counts all documents")
    fun all() =
        SQLiteDB().use(CountFunctions::all)

    @Test
    @DisplayName("byFields counts documents by a numeric value")
    fun byFieldsNumeric() =
        SQLiteDB().use(CountFunctions::byFieldsNumeric)

    @Test
    @DisplayName("byFields counts documents by a alphanumeric value")
    fun byFieldsAlpha() =
        SQLiteDB().use(CountFunctions::byFieldsAlpha)

    @Test
    @DisplayName("byContains fails")
    fun byContainsMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(CountFunctions::byContainsMatch) }
    }

    @Test
    @DisplayName("byJsonPath fails")
    fun byJsonPathMatch() {
        assertThrows<DocumentException> { SQLiteDB().use(CountFunctions::byJsonPathMatch) }
    }
}
