package solutions.bitbadger.documents.groovy.tests

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.DocumentIndex

import static org.junit.jupiter.api.Assertions.assertEquals

/**
 * Unit tests for the `DocumentIndex` enum
 */
@DisplayName('Groovy | DocumentIndex')
class DocumentIndexTest {

    @Test
    @DisplayName('FULL uses proper SQL')
    void fullSQL() {
        assertEquals '', DocumentIndex.FULL.sql, 'The SQL for Full is incorrect'
    }

    @Test
    @DisplayName('OPTIMIZED uses proper SQL')
    void optimizedSQL() {
        assertEquals ' jsonb_path_ops', DocumentIndex.OPTIMIZED.sql, 'The SQL for Optimized is incorrect'
    }
}
