package solutions.bitbadger.documents.kotlinx.tests

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.kotlinx.DocumentConfig
import kotlin.test.assertFalse
import kotlin.test.assertTrue

/**
 * Unit tests for the `Configuration` object
 */
@DisplayName("KotlinX | DocumentConfig")
class DocumentConfigTest {

    @Test
    @DisplayName("Default JSON options are as expected")
    fun defaultJsonOptions() {
        assertTrue(DocumentConfig.options.configuration.encodeDefaults, "Encode Defaults should have been set")
        assertFalse(DocumentConfig.options.configuration.explicitNulls, "Explicit Nulls should not have been set")
        assertTrue(DocumentConfig.options.configuration.coerceInputValues, "Coerce Input Values should have been set")
    }
}
