package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

/**
 * PostgreSQL integration tests for the `Delete` object / `deleteBy*` connection extension functions
 */
@DisplayName("Scala | PostgreSQL: Delete")
class PostgreSQLDeleteIT:

  @Test
  @DisplayName("byId deletes a matching ID")
  def byIdMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byIdMatch(db) }

  @Test
  @DisplayName("byId succeeds when no ID matches")
  def byIdNoMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byIdNoMatch(db) }

  @Test
  @DisplayName("byFields deletes matching documents")
  def byFieldsMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byFieldsMatch(db) }

  @Test
  @DisplayName("byFields succeeds when no documents match")
  def byFieldsNoMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byFieldsNoMatch(db) }

  @Test
  @DisplayName("byContains deletes matching documents")
  def byContainsMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byContainsMatch(db) }

  @Test
  @DisplayName("byContains succeeds when no documents match")
  def byContainsNoMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byContainsNoMatch(db) }

  @Test
  @DisplayName("byJsonPath deletes matching documents")
  def byJsonPathMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byJsonPathMatch(db) }

  @Test
  @DisplayName("byJsonPath succeeds when no documents match")
  def byJsonPathNoMatch(): Unit =
    Using(PgDB()) { db => DeleteFunctions.byJsonPathNoMatch(db) }
