package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}

import scala.util.Using

/**
 * PostgreSQL integration tests for the `Exists` object / `existsBy*` connection extension functions
 */
@DisplayName("Scala | PostgreSQL: Exists")
class PostgreSQLExistsIT:

  @Test
  @DisplayName("byId returns true when a document matches the ID")
  def byIdMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byIdMatch(db) }

  @Test
  @DisplayName("byId returns false when no document matches the ID")
  def byIdNoMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byIdNoMatch(db) }

  @Test
  @DisplayName("byFields returns true when documents match")
  def byFieldsMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byFieldsMatch(db) }

  @Test
  @DisplayName("byFields returns false when no documents match")
  def byFieldsNoMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byFieldsNoMatch(db) }

  @Test
  @DisplayName("byContains returns true when documents match")
  def byContainsMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byContainsMatch(db) }

  @Test
  @DisplayName("byContains returns false when no documents match")
  def byContainsNoMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byContainsNoMatch(db) }

  @Test
  @DisplayName("byJsonPath returns true when documents match")
  def byJsonPathMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byJsonPathMatch(db) }

  @Test
  @DisplayName("byJsonPath returns false when no documents match")
  def byJsonPathNoMatch(): Unit =
    Using(PgDB()) { db => ExistsFunctions.byJsonPathNoMatch(db) }
