package solutions.bitbadger.documents.scala.tests.integration

import org.junit.jupiter.api.{DisplayName, Test}
import org.junit.jupiter.api.Assertions.assertThrows
import solutions.bitbadger.documents.DocumentException

import scala.util.Using

/**
 * SQLite integration tests for the `Definition` object / `ensure*` connection extension functions
 */
@DisplayName("Scala | SQLite: Definition")
class SQLiteDefinitionIT:

  @Test
  @DisplayName("ensureTable creates table and index")
  def ensureTable(): Unit =
    Using(SQLiteDB()) { db => DefinitionFunctions.ensureTable(db) }

  @Test
  @DisplayName("ensureFieldIndex creates an index")
  def ensureFieldIndex(): Unit =
    Using(SQLiteDB()) { db => DefinitionFunctions.ensureFieldIndex(db) }

  @Test
  @DisplayName("ensureDocumentIndex creates a full index")
  def ensureDocumentIndexFull(): Unit =
    Using(SQLiteDB()) { db =>
      assertThrows(classOf[DocumentException], () => DefinitionFunctions.ensureDocumentIndexFull(db))
    }
